<h1>Automated encryption and decryption in Git repositories</h1>

<p>It is possible to use automated encryption and decryption in Git repositories
because of the filter drivers that consist of a clean command and a smudge
command. Where the clean "command is used to convert the contents of worktree
file[s] upon checkin" in a similar way to how the smudge "command is fed the
blob object from its standard input, and its standard output is used to update
the worktree file." (The quotes are from gitattributes(5).)</p>

<h2>Working with OpenSSL symmetric-key encrypted files in a repository</h2>

<p><strong>1)</strong> If one does not know the password to the encrypted files, the workflow is
the same as always: work on the unencrypted files and commit the changes, etc.</p>

<p><strong>2)</strong> This is not always the case, though. If you are one of the lucky ones
and know the password and the cipher, and want to take part of the encrypted
content (here ending with the file extension ".senc" (symmetric-key
encrypted)), the following commands will do the job:</p>

<pre><code>git clone git://example.com/repository.git
cd repository
git config filter.crypt_sym.clean "openssl CIPHER -a -nosalt -pass pass:PASSWORD"
git config filter.crypt_sym.smudge "openssl CIPHER -a -nosalt -d -pass pass:PASSWORD"
git config diff.crypt_sym.command PATH_TO_crypt_diff
echo '*.senc filter=crypt_sym diff=crypt_sym' &gt;&gt; .git/info/attributes
</code></pre>

<p>Then finally checkout the files that you want to decrypt:</p>

<pre><code>git checkout -- FILE.senc FILE2.senc
</code></pre>

<p>and work on them as usual.</p>

<p><strong>Notice</strong> that you must replace CIPHER with the actual cipher that is used, in
this repository "example.senc" is encrypted using aes-256-cbc. The same is with
the PASSWORD, where it is "writecode" in this case. Also PATH_TO_crypt_diff
must be replaced with the path to the shell script crypt_diff, that is located
in this repository, in order to be able to view plaintext diffs between the
encrypted blob files and the plaintext worktree files.</p>

<p><strong>3)</strong> To encrypt new files, all you have to do is to create them with the correct
file extension (if not a sole wildcard is used instead of "*.senc" in
.git/info/attributes) and later run <code>git add</code>. The same procedure is also used
when initializing a new repository, except that <code>git init</code> should be run before
the <code>git add</code> and that the two first steps are also skipped (<code>git clone</code> and
<code>cd</code>) in the process above.</p>

<h2>Working with GnuPG public-key encrypted files in a repository</h2>

<p><strong>1)</strong> Same as in the previous subsection.</p>

<p><strong>2)</strong> Same as in the previous subsection, except that the lucky one, in this
case, is having the private key corresponding to the public key NAME (remember to
change it below). (<strong>Notice</strong> that the "-r" option can be given multiple times,
which leads to broadcast encryption.) Changes made, in the above instructions,
are presented below.</p>

<pre><code>git config filter.crypt_pub.clean "gpg -ea -q --batch --no-tty -r NAME"
git config filter.crypt_pub.smudge "gpg -d -q --batch --no-tty"
git config diff.crypt_pub.command PATH_TO_crypt_diff
echo '*.penc filter=crypt_pub diff=crypt_pub' &gt;&gt; .git/info/attributes
</code></pre>

<p>It is recommended to use a specific key pair only for this very repository and
to make sure that it is passwordless as the process is supposed to be
automatic.</p>

<p><strong>3)</strong> Same as in the previous subsection, except that the file extension for
the encrypted files, in this example, is ".penc" (public-key encrypted) instead
of ".senc".</p>

<p><strong>CAVEAT</strong>: Two GnuPG public-key encrypted versions of the same file are
different (because of the randomly-generated session keys), which leads to the
fact that Git will track these sort of "unreal changes" that usually occur when
one reverts a change. This is not the case with OpenSSL symmetric-key
encryption when salt is disabled.</p>

<h2>See also</h2>

<p><a href="http://www.gnupg.org/documentation/manpage.en.html">gpg(1)</a>, <a href="http://www.openbsd.org/cgi-bin/man.cgi?query=openssl&amp;apropos=0&amp;sektion=1&amp;manpath=OpenBSD+Current&amp;arch=i386&amp;format=html">openssl(1)</a>, <a href="http://www.kernel.org/pub/software/scm/git/docs/gitattributes.html">gitattributes(5)</a></p>

<p><b><i>The README is from commit 96b05a8f09b64cde71d33fcea09b3c620383bec0.
For the latest version, check the Git repository.</i></b></p>
<p><b><i>In order to contact Je, add your message to the file CONTACT in the
Git repository on the mob branch which is <a
href="http://repo.or.cz/h/mob.html">writable by everyone</a>.</i></b></p>
